<?php
/**
 * @link http://www.yiiframework.com/
 * @copyright Copyright (c) 2008 Yii Software LLC
 * @license http://www.yiiframework.com/license/
 */

namespace wdigital\cms\inspinia\generators\crud;

use Yii;
use yii\db\ActiveRecord;
use yii\db\BaseActiveRecord;
use yii\db\Schema;
use yii\gii\CodeFile;
use yii\helpers\Inflector;
use yii\helpers\VarDumper;
use yii\web\Controller;

/**
 * Generates CRUD
 *
 * @property array $columnNames Model column names. This property is read-only.
 * @property string $controllerID The controller ID (without the module ID prefix). This property is
 * read-only.
 * @property array $searchAttributes Searchable attributes. This property is read-only.
 * @property boolean|\yii\db\TableSchema $tableSchema This property is read-only.
 * @property string $viewPath The controller view path. This property is read-only.
 *
 * @author Qiang Xue <qiang.xue@gmail.com>
 * @since 2.0
 */
class Generator extends \yii\gii\Generator
{
    public $modelClass;
    public $controllerClass;
    public $viewPath;
    public $baseControllerClass = 'yii\web\Controller';
    public $indexWidgetType = 'grid';
    public $searchModelClass = '';
    public $translatableFields;
    /**
     * @var boolean whether to wrap the `GridView` or `ListView` widget with the `yii\widgets\Pjax` widget
     * @since 2.0.5
     */
    public $enablePjax = false;


    /**
     * @inheritdoc
     */
    public function getName()
    {
        return 'Inspinia CRUD Generator';
    }

    /**
     * @inheritdoc
     */
    public function getDescription()
    {
        return 'This generator generates a controller and INSPINIA themed views that implement CRUD (Create, Read, Update, Delete)
            operations for the specified data model.<br> Couple of tips: <br>If model title field should be sluggable, name the slug column `slug` and source column `title`<br>
            If there are attributes containing foreign key(contain `_id`), fields will be automatically created as dropdown`s
            <br>If model needs to have title image, name the column `image`<br>';
    }

    /**
     * @inheritdoc
     */
    public function rules()
    {
        return array_merge(parent::rules(), [
            [['controllerClass', 'modelClass', 'searchModelClass', 'baseControllerClass'], 'filter', 'filter' => 'trim'],
            [['modelClass', 'controllerClass', 'baseControllerClass', 'indexWidgetType'], 'required'],
            [['searchModelClass'], 'compare', 'compareAttribute' => 'modelClass', 'operator' => '!==', 'message' => 'Search Model Class must not be equal to Model Class.'],
            [['modelClass', 'controllerClass', 'baseControllerClass', 'searchModelClass'], 'match', 'pattern' => '/^[\w\\\\]*$/', 'message' => 'Only word characters and backslashes are allowed.'],
            [['modelClass'], 'validateClass', 'params' => ['extends' => BaseActiveRecord::className()]],
            [['baseControllerClass'], 'validateClass', 'params' => ['extends' => Controller::className()]],
            [['controllerClass'], 'match', 'pattern' => '/Controller$/', 'message' => 'Controller class name must be suffixed with "Controller".'],
            [['controllerClass'], 'match', 'pattern' => '/(^|\\\\)[A-Z][^\\\\]+Controller$/', 'message' => 'Controller class name must start with an uppercase letter.'],
            [['controllerClass', 'searchModelClass'], 'validateNewClass'],
            [['indexWidgetType'], 'in', 'range' => ['grid', 'list']],
            [['modelClass'], 'validateModelClass'],
            [['enableI18N', 'enablePjax'], 'boolean'],
            [['messageCategory'], 'validateMessageCategory', 'skipOnEmpty' => false],
            [['viewPath', 'translatableFields'], 'safe'],
        ]);
    }

    /**
     * @inheritdoc
     */
    public function attributeLabels()
    {
        return array_merge(parent::attributeLabels(), [
            'modelClass' => 'Model Class',
            'controllerClass' => 'Controller Class',
            'viewPath' => 'View Path',
            'baseControllerClass' => 'Base Controller Class',
            'indexWidgetType' => 'Widget Used in Index Page',
            'searchModelClass' => 'Search Model Class',
            'enablePjax' => 'Enable Pjax',
        ]);
    }

    /**
     * @inheritdoc
     */
    public function hints()
    {
        return array_merge(parent::hints(), [
            'modelClass' => 'This is the ActiveRecord class associated with the table that CRUD will be built upon.
                You should provide a fully qualified class name, e.g., <code>app\models\Post</code>.',
            'controllerClass' => 'This is the name of the controller class to be generated. You should
                provide a fully qualified namespaced class (e.g. <code>app\controllers\PostController</code>),
                and class name should be in CamelCase with an uppercase first letter. Make sure the class
                is using the same namespace as specified by your application\'s controllerNamespace property.',
            'viewPath' => 'Specify the directory for storing the view scripts for the controller. You may use path alias here, e.g.,
                <code>/var/www/basic/controllers/views/post</code>, <code>@app/views/post</code>. If not set, it will default
                to <code>@app/views/ControllerID</code>',
            'baseControllerClass' => 'This is the class that the new CRUD controller class will extend from.
                You should provide a fully qualified class name, e.g., <code>yii\web\Controller</code>.',
            'indexWidgetType' => 'This is the widget type to be used in the index page to display list of the models.
                You may choose either <code>GridView</code> or <code>ListView</code>',
            'searchModelClass' => 'This is the name of the search model class to be generated. You should provide a fully
                qualified namespaced class name, e.g., <code>app\models\PostSearch</code>.',
            'enablePjax' => 'This indicates whether the generator should wrap the <code>GridView</code> or <code>ListView</code>
                widget on the index page with <code>yii\widgets\Pjax</code> widget. Set this to <code>true</code> if you want to get
                sorting, filtering and pagination without page refreshing.',
            'translatableFields' => '<strong>Use only if option Enable I18N is checked.</strong> Please indicate which database columns should be translatable (seperated by comma <code>,</code>). These fields in
            CRUD forms will be in language specific tabs',
        ]);
    }

    /**
     * @inheritdoc
     */
    public function requiredTemplates()
    {
        return ['controller.php'];
    }

    /**
     * @inheritdoc
     */
    public function stickyAttributes()
    {
        return array_merge(parent::stickyAttributes(), ['baseControllerClass', 'indexWidgetType']);
    }

    /**
     * Checks if model class is valid
     */
    public function validateModelClass()
    {
        /* @var $class ActiveRecord */
        $class = $this->modelClass;
        $pk = $class::primaryKey();
        if (empty($pk)) {
            $this->addError('modelClass', "The table associated with $class must have primary key(s).");
        }
    }

    /**
     * @inheritdoc
     */
    public function generate()
    {
        $controllerFile = Yii::getAlias('@' . str_replace('\\', '/', ltrim($this->controllerClass, '\\')) . '.php');

        $files = [
            new CodeFile($controllerFile, $this->render('controller.php')),
        ];

        if (!empty($this->searchModelClass)) {
            $searchModel = Yii::getAlias('@' . str_replace('\\', '/', ltrim($this->searchModelClass, '\\') . '.php'));
            $files[] = new CodeFile($searchModel, $this->render('search.php'));
        }
        if (!empty($this->translatableFields)) {
            $this->translatableFields = \yii\helpers\StringHelper::explode($this->translatableFields);
        }
        $viewPath = $this->getViewPath();
        $templatePath = $this->getTemplatePath() . '/views';
        foreach (scandir($templatePath) as $file) {
            if (empty($this->searchModelClass) && $file === '_search.php') {
                continue;
            }
            if (is_file($templatePath . '/' . $file) && pathinfo($file, PATHINFO_EXTENSION) === 'php') {
                $files[] = new CodeFile("$viewPath/$file", $this->render("views/$file"));
            }
        }
        $this->translatableFields = implode(',', $this->translatableFields);
        return $files;
    }

    /**
     * @return string the controller ID (without the module ID prefix)
     */
    public function getControllerID()
    {
        $pos = strrpos($this->controllerClass, '\\');
        $class = substr(substr($this->controllerClass, $pos + 1), 0, -10);

        return Inflector::camel2id($class);
    }

    /**
     * @return string the controller view path
     */
    public function getViewPath()
    {
        if (empty($this->viewPath)) {
            return Yii::getAlias('@app/views/' . $this->getControllerID());
        } else {
            return Yii::getAlias($this->viewPath);
        }
    }

    public function getNameAttribute()
    {
        foreach ($this->getColumnNames() as $name) {
            if (!strcasecmp($name, 'name') || !strcasecmp($name, 'title')) {
                return $name;
            }
        }
        /* @var $class \yii\db\ActiveRecord */
        $class = $this->modelClass;
        $pk = $class::primaryKey();

        return $pk[0];
    }

    /**
     * Generates code for active field
     * @param string $attribute
     * @return string
     */
    public function generateActiveField($attribute)
    {
        $tableSchema = $this->getTableSchema();
        if ($tableSchema === false || !isset($tableSchema->columns[$attribute])) {
            if (preg_match('/^(password|pass|passwd|passcode)$/i', $attribute)) {
                return "\$form->field(\$model, '$attribute')->passwordInput()";
            } else {
                return "\$form->field(\$model, '$attribute')";
            }
        }
        $column = $tableSchema->columns[$attribute];
        if ($column->phpType === 'boolean') {
            return "\$form->field(\$model, '$attribute')->checkbox()";
        } elseif ($column->type === 'text') {
            return "\$form->field(\$model, '$attribute')->textarea(['rows' => 6, 'class' => 'ckeditor'])";
        } elseif ($column->type === 'date') {
            return "\$form->field(\$model, '$attribute')->textInput(['class' => 'form-control datepicker', 'value' => Yii::\$app->formatter->asDate(\$model->date, 'php:d.m.Y')])";
        } elseif ($column->type === 'smallint' && $column->size === 1) {
            return "\$form->field(\$model, '$attribute')->checkbox(['class' => 'js-icheck'])";
        } else {
            if(preg_match('/(_id)/i', $column->name)){
               return "\$form->field(\$model, '$attribute')->dropDownList([], ['class' => 'js-select2 form-control'])";
            }
            if(preg_match('/(image)/i', $column->name)){
               return $this->renderImageCropper();
            }
            if (preg_match('/^(password|pass|passwd|passcode)$/i', $column->name)) {
                $input = 'passwordInput';
            } else {
                $input = 'textInput';
            }
            if (is_array($column->enumValues) && count($column->enumValues) > 0) {
                $dropDownOptions = [];
                foreach ($column->enumValues as $enumValue) {
                    $dropDownOptions[$enumValue] = Inflector::humanize($enumValue);
                }
                return "\$form->field(\$model, '$attribute')->dropDownList("
                    . preg_replace("/\n\s*/", ' ', VarDumper::export($dropDownOptions)).", ['prompt' => ''])";
            } elseif ($column->phpType !== 'string' || $column->size === null) {
                if(preg_match('/^(slug)$/i', $column->name)) {
                    return "\$form->field(\$model, '$attribute')->$input(['data-slug-target' => 'new-{$this->getControllerID()}'])";
                } elseif (preg_match('/^(title)$/i', $column->name)) {
                    return "\$form->field(\$model, '$attribute')->$input(['data-slug-field' => 'new-{$this->getControllerID()}', 'class' => 'form control js-slug-field'])";
                } else {
                    return "\$form->field(\$model, '$attribute')->$input()";
                }
            } else {
                if(preg_match('/^(slug)$/i', $column->name)) {
                    return "\$form->field(\$model, '$attribute')->$input(['maxlength' => true, 'data-slug-target' => 'new-{$this->getControllerID()}'])";
                } elseif(preg_match('/^(title)$/i', $column->name)) {
                    return "\$form->field(\$model, '$attribute')->$input(['maxlength' => true, 'data-slug-field' => 'new-{$this->getControllerID()}', 'class' => 'form-control js-slug-field'])";
                } else {
                    return "\$form->field(\$model, '$attribute')->$input(['maxlength' => true])";
                }
            }
        }
    }

    /**
     * Generates code for active field
     * @param string $attribute
     * @return string
     */
    public function generateTranslatableActiveField($attribute, $modelName)
    {
        $classOfModel = $this->messageCategory;
        $tableSchema = $this->getTranslatedTableSchema();
        $upperCasedAttribute = ucfirst($attribute);
        if ($tableSchema === false || !isset($tableSchema->columns[$attribute])) {
            if (preg_match('/^(password|pass|passwd|passcode)$/i', $attribute)) {
                return "\$form->field(\$translatedModel, \"[{\$language[\"id\"]}]$attribute\")->passwordInput()->label(Yii::t('$classOfModel', '$upperCasedAttribute', [], \$language['code']));";
            } else {
                return "\$form->field(\$translatedModel, \"[{\$language[\"id\"]}]$attribute\")->label(Yii::t('$classOfModel', '$upperCasedAttribute', [], \$language['code']));";
            }
        }
        $column = $tableSchema->columns[$attribute];
        if ($column->phpType === 'boolean') {
            return "\$form->field(\$translatedModel, \"[{\$language[\"id\"]}]$attribute\")->checkbox(['value' => \$model->getAttribute('$attribute', \$language[\"code\"])])->label(Yii::t('$classOfModel', '$upperCasedAttribute', [], \$language['code']));";
        } elseif ($column->type === 'text') {
            return "\$form->field(\$translatedModel, \"[{\$language[\"id\"]}]$attribute\")->textarea(['rows' => 6, 'class' => 'ckeditor'])->label(Yii::t('$classOfModel', '$upperCasedAttribute', [], \$language['code']));";
        } elseif ($column->type === 'date') {
            return "\$form->field(\$translatedModel, \"[{\$language[\"id\"]}]$attribute\")->textInput(['class' => 'form-control datepicker', 'value' => Yii::\$app->formatter->asDate(\$model->date, 'php:d.m.Y')])->label(Yii::t('$classOfModel', '$upperCasedAttribute', [], \$language['code']));";
        } elseif ($column->type === 'smallint' && $column->size === 1) {
            return "\$form->field(\$translatedModel, \"[{\$language[\"id\"]}]$attribute\")->checkbox(['class' => 'js-icheck', 'value' => \$model->getAttribute('$attribute', \$language[\"code\"])])->label(Yii::t('$classOfModel', '$upperCasedAttribute', [], \$language['code']));";
        } else {
            if(preg_match('/(_id)/i', $column->name)){
                return "\$form->field(\$translatedModel, \"[{\$language[\"id\"]}]$attribute\")->dropDownList([], ['class' => 'js-select2 form-control'])->label(Yii::t('$classOfModel', '$upperCasedAttribute', [], \$language['code']));";
            }
            if(preg_match('/(image)/i', $column->name)){
                return $this->renderImageCropper();
            }
            if (preg_match('/^(password|pass|passwd|passcode)$/i', $column->name)) {
                $input = 'passwordInput';
            } else {
                $input = 'textInput';
            }
            if (is_array($column->enumValues) && count($column->enumValues) > 0) {
                $dropDownOptions = [];
                foreach ($column->enumValues as $enumValue) {
                    $dropDownOptions[$enumValue] = Inflector::humanize($enumValue);
                }
                return "\$form->field(\$translatedModel, '$attribute')->dropDownList("
                    . preg_replace("/\n\s*/", ' ', VarDumper::export($dropDownOptions)).", ['prompt' => ''])";
            } elseif ($column->phpType !== 'string' || $column->size === null) {
                if(preg_match('/^(slug)$/i', $column->name)) {
                    return "\$form->field(\$translatedModel, \"[{\$language[\"id\"]}]$attribute\")->$input(['data-slug-target' => \"new-{$this->getControllerID()}-{\$language['code']}\"])->label(Yii::t('$classOfModel', '$upperCasedAttribute', [], \$language['code']));";
                } elseif (preg_match('/^(title)$/i', $column->name)) {
                    return "\$form->field(\$translatedModel, \"[{\$language[\"id\"]}]$attribute\")->$input(['data-slug-field' => \"new-{$this->getControllerID()}-{\$language['code']}\", 'class' => 'form control js-slug-field'])->label(Yii::t('$classOfModel', '$upperCasedAttribute', [], \$language['code']));";
                } else {
                    return "\$form->field(\$translatedModel, \"[{\$language[\"id\"]}]$attribute\")->$input()->label(Yii::t('$classOfModel', '$upperCasedAttribute', [], \$language['code']));";
                }
            } else {
                if(preg_match('/^(slug)$/i', $column->name)) {
                    return "\$form->field(\$translatedModel, \"[{\$language[\"id\"]}]$attribute\")->$input(['maxlength' => true, 'data-slug-target' => \"new-{$this->getControllerID()}-{\$language['code']}\"])->label(Yii::t('$classOfModel', '$upperCasedAttribute', [], \$language['code']));";
                } elseif(preg_match('/^(title)$/i', $column->name)) {
                    return "\$form->field(\$translatedModel, \"[{\$language[\"id\"]}]$attribute\")->$input(['maxlength' => true, 'data-slug-field' => \"new-{$this->getControllerID()}-{\$language['code']}\", 'class' => 'form-control js-slug-field'])->label(Yii::t('$classOfModel', '$upperCasedAttribute', [], \$language['code']));";
                } else {
                    return "\$form->field(\$translatedModel, \"[{\$language[\"id\"]}]$attribute\")->$input(['maxlength' => true])->label(Yii::t('$classOfModel', '$upperCasedAttribute', [], \$language['code']));";
                }
            }
        }
    }

    /**
     * Generates code for active search field
     * @param string $attribute
     * @return string
     */
    public function generateActiveSearchField($attribute)
    {
        $tableSchema = $this->getTableSchema();
        if ($tableSchema === false) {
            return "\$form->field(\$model, '$attribute')";
        }
        $column = $tableSchema->columns[$attribute];
        if ($column->phpType === 'boolean') {
            return "\$form->field(\$model, '$attribute')->checkbox()";
        } else {
            return "\$form->field(\$model, '$attribute')";
        }
    }

    /**
     * Generates column format
     * @param \yii\db\ColumnSchema $column
     * @return string
     */
    public function generateColumnFormat($column)
    {
        if ($column->phpType === 'boolean') {
            return 'boolean';
        } elseif ($column->type === 'text') {
            return 'ntext';
        } elseif (stripos($column->name, 'time') !== false && $column->phpType === 'integer') {
            return 'datetime';
        } elseif (stripos($column->name, 'email') !== false) {
            return 'email';
        } elseif (stripos($column->name, 'url') !== false) {
            return 'url';
        } else {
            return 'text';
        }
    }

    /**
     * Generates validation rules for the search model.
     * @return array the generated validation rules
     */
    public function generateSearchRules()
    {
        if (($table = $this->getTableSchema()) === false) {
            return ["[['" . implode("', '", $this->getColumnNames()) . "'], 'safe']"];
        }
        $types = [];
        foreach ($table->columns as $column) {
            switch ($column->type) {
                case Schema::TYPE_SMALLINT:
                case Schema::TYPE_INTEGER:
                case Schema::TYPE_BIGINT:
                    $types['integer'][] = $column->name;
                    break;
                case Schema::TYPE_BOOLEAN:
                    $types['boolean'][] = $column->name;
                    break;
                case Schema::TYPE_FLOAT:
                case Schema::TYPE_DOUBLE:
                case Schema::TYPE_DECIMAL:
                case Schema::TYPE_MONEY:
                    $types['number'][] = $column->name;
                    break;
                case Schema::TYPE_DATE:
                case Schema::TYPE_TIME:
                case Schema::TYPE_DATETIME:
                case Schema::TYPE_TIMESTAMP:
                default:
                    $types['safe'][] = $column->name;
                    break;
            }
        }

        $rules = [];
        foreach ($types as $type => $columns) {
            $rules[] = "[['" . implode("', '", $columns) . "'], '$type']";
        }

        return $rules;
    }

    /**
     * @return array searchable attributes
     */
    public function getSearchAttributes()
    {
        return $this->getColumnNames();
    }

    /**
     * Generates the attribute labels for the search model.
     * @return array the generated attribute labels (name => label)
     */
    public function generateSearchLabels()
    {
        /* @var $model \yii\base\Model */
        $model = new $this->modelClass();
        $attributeLabels = $model->attributeLabels();
        $labels = [];
        foreach ($this->getColumnNames() as $name) {
            if (isset($attributeLabels[$name])) {
                $labels[$name] = $attributeLabels[$name];
            } else {
                if (!strcasecmp($name, 'id')) {
                    $labels[$name] = 'ID';
                } else {
                    $label = Inflector::camel2words($name);
                    if (!empty($label) && substr_compare($label, ' id', -3, 3, true) === 0) {
                        $label = substr($label, 0, -3) . ' ID';
                    }
                    $labels[$name] = $label;
                }
            }
        }

        return $labels;
    }

    /**
     * Generates search conditions
     * @return array
     */
    public function generateSearchConditions()
    {
        $columns = [];
        if (($table = $this->getTableSchema()) === false) {
            $class = $this->modelClass;
            /* @var $model \yii\base\Model */
            $model = new $class();
            foreach ($model->attributes() as $attribute) {
                $columns[$attribute] = 'unknown';
            }
        } else {
            foreach ($table->columns as $column) {
                $columns[$column->name] = $column->type;
            }
        }

        $likeConditions = [];
        $hashConditions = [];
        foreach ($columns as $column => $type) {
            switch ($type) {
                case Schema::TYPE_SMALLINT:
                case Schema::TYPE_INTEGER:
                case Schema::TYPE_BIGINT:
                case Schema::TYPE_BOOLEAN:
                case Schema::TYPE_FLOAT:
                case Schema::TYPE_DOUBLE:
                case Schema::TYPE_DECIMAL:
                case Schema::TYPE_MONEY:
                case Schema::TYPE_DATE:
                case Schema::TYPE_TIME:
                case Schema::TYPE_DATETIME:
                case Schema::TYPE_TIMESTAMP:
                    $hashConditions[] = "'{$column}' => \$this->{$column},";
                    break;
                default:
                    $likeConditions[] = "->andFilterWhere(['like', '{$column}', \$this->{$column}])";
                    break;
            }
        }

        $conditions = [];
        if (!empty($hashConditions)) {
            $conditions[] = "\$query->andFilterWhere([\n"
                . str_repeat(' ', 12) . implode("\n" . str_repeat(' ', 12), $hashConditions)
                . "\n" . str_repeat(' ', 8) . "]);\n";
        }
        if (!empty($likeConditions)) {
            $conditions[] = "\$query" . implode("\n" . str_repeat(' ', 12), $likeConditions) . ";\n";
        }

        return $conditions;
    }

    /**
     * Generates URL parameters
     * @return string
     */
    public function generateUrlParams()
    {
        /* @var $class ActiveRecord */
        $class = $this->modelClass;
        $pks = $class::primaryKey();
        if (count($pks) === 1) {
            if (is_subclass_of($class, 'yii\mongodb\ActiveRecord')) {
                return "'id' => (string)\$model->{$pks[0]}";
            } else {
                return "'id' => \$model->{$pks[0]}";
            }
        } else {
            $params = [];
            foreach ($pks as $pk) {
                if (is_subclass_of($class, 'yii\mongodb\ActiveRecord')) {
                    $params[] = "'$pk' => (string)\$model->$pk";
                } else {
                    $params[] = "'$pk' => \$model->$pk";
                }
            }

            return implode(', ', $params);
        }
    }

    /**
     * Generates action parameters
     * @return string
     */
    public function generateActionParams()
    {
        /* @var $class ActiveRecord */
        $class = $this->modelClass;
        $pks = $class::primaryKey();
        if (count($pks) === 1) {
            return '$id';
        } else {
            return '$' . implode(', $', $pks);
        }
    }

    /**
     * Generates parameter tags for phpdoc
     * @return array parameter tags for phpdoc
     */
    public function generateActionParamComments()
    {
        /* @var $class ActiveRecord */
        $class = $this->modelClass;
        $pks = $class::primaryKey();
        if (($table = $this->getTableSchema()) === false) {
            $params = [];
            foreach ($pks as $pk) {
                $params[] = '@param ' . (substr(strtolower($pk), -2) == 'id' ? 'integer' : 'string') . ' $' . $pk;
            }

            return $params;
        }
        if (count($pks) === 1) {
            return ['@param ' . $table->columns[$pks[0]]->phpType . ' $id'];
        } else {
            $params = [];
            foreach ($pks as $pk) {
                $params[] = '@param ' . $table->columns[$pk]->phpType . ' $' . $pk;
            }

            return $params;
        }
    }

    /**
     * Returns table schema for current model class or false if it is not an active record
     * @return boolean|\yii\db\TableSchema
     */
    public function getTableSchema()
    {
        /* @var $class ActiveRecord */
        $class = $this->modelClass;
        if (is_subclass_of($class, 'yii\db\ActiveRecord')) {
            return $class::getTableSchema();
        } else {
            return false;
        }
    }

    /**
     * Returns table schema for current model class or false if it is not an active record
     * @return boolean|\yii\db\TableSchema
     */
    public function getTranslatedTableSchema()
    {
        /* @var $class ActiveRecord */
        $class = $this->modelClass.'Translation';
        if (is_subclass_of($class, 'yii\db\ActiveRecord')) {
            return $class::getTableSchema();
        } else {
            return false;
        }
    }


    /**
     * @return array model column names
     */
    public function getColumnNames()
    {
        /* @var $class ActiveRecord */
        $class = $this->modelClass;
        if (is_subclass_of($class, 'yii\db\ActiveRecord')) {
            return $class::getTableSchema()->getColumnNames();
        } else {
            /* @var $model \yii\base\Model */
            $model = new $class();

            return $model->attributes();
        }
    }

    /**
     * @return array model column names
     */
    public function getTranslatedColumnNames()
    {
        /* @var $class ActiveRecord */
        $class = $this->modelClass.'Translation';
        if (is_subclass_of($class, 'yii\db\ActiveRecord')) {
            return $class::getTableSchema()->getColumnNames();
        } else {
            /* @var $model \yii\base\Model */
            $model = new $class();

            return $model->attributes();
        }
    }

    public function renderImageCropper()
    {
        return '    <div class="form-group text-r">
        <label for="image" class="control-label"> '.$this->getControllerID().' </label>
        <div class="js-img-crop-container">
            <img src="/wd_logo.png"
                 alt="Picture"
                 data-backup-src=""
                 >
        </div>
        <div class="btn-group">
            <label title="Upload image file" for="image" class="btn btn-primary btn-sm">
                <input type="file" accept="image/*" name="'.ucfirst($this->getControllerID()).'[image]" id="image" class="hide js-input-image">
                <?=Yii::t("'.$this->getControllerID().'", "Upload image"); ?>
            </label>
        </div>
        <span class="help-block"></span>
    </div>
    <input type="hidden" name="x" value="0">
    <input type="hidden" name="y" value="0">
    <input type="hidden" name="w" value="0">
    <input type="hidden" name="h" value="0">';
    }
}
